clear all;clc;

addpath C:\Program Files\Motion Lab Systems\C3Dserver\MATLAB\C3D

test = c3dserver();

openc3d(test,1,'20_01.c3d');

frames = nframes(test);

names = {'RANK','LANK','RKNE','LKNE','RFWT','LFWT','STRN','CLAV','RSHO','LSHO','RELB','LELB','RWRA','LWRA'};

nmarks = length(names);

XYZ = [];

for i = 1:nmarks
    XYZ = [XYZ,0.001*get3dtarget(test,['Justin1:',names{i}])];
end

ZERO = 0.5*(XYZ(:,1:3) + XYZ(:,4:6));

% ZERO(:,1) = ZERO(:,1) + 0.1;

for i=1:nmarks
    XYZ(:,3*(i-1)+1:3*i) = XYZ(:,3*(i-1)+1:3*i) - ZERO;
end

XYZ = 0.93*XYZ;
% 
% save('20_01.xyz','XYZ','frames','nmarks','names');

% load 20_01.xyz;

%%

m = primus_fast4_mex;
%%
figure(1);clf;


state = zeros(30+29,1);
state(3) = 0.8;

primus_draw(m,state);

%
% nmarks = 10;
load pos;
for i = 1:1%:frames
    plot3(XYZ(i,1:3:nmarks*3),XYZ(i,2:3:nmarks*3),XYZ(i,3:3:nmarks*3),'bo','LineWidth',3); hold on;
    plot3(pos(i,1:3:nmarks*3),pos(i,2:3:nmarks*3),pos(i,3:3:nmarks*3),'ro','LineWidth',3); hold off;
    axis equal;
    xlabel('x');
    ylabel('y');
    pause(0.03);
end
%%
% figure(1);clf;
% plot(XYZ)

dXYZ = [zeros(1,size(XYZ,2));diff(XYZ)*120];

% figure(2);clf;

[b,a] = butter(2,10/60);
dXYZf = filtfilt(b,a,dXYZ);
% plot(dXYZf)

OUTPUT = [XYZ,dXYZf];

allnames = cell(1,2*3*nmarks);
for i = 1:nmarks
    allnames{3*(i-1)+1} = [names{i},'_x'];
    allnames{3*(i-1)+2} = [names{i},'_y'];
    allnames{3*(i-1)+3} = [names{i},'_z'];    
    allnames{3*nmarks+3*(i-1)+1} = [names{i},'_xd'];
    allnames{3*nmarks+3*(i-1)+2} = [names{i},'_yd'];
    allnames{3*nmarks+3*(i-1)+3} = [names{i},'_zd'];    
end

mrdplot_gen(OUTPUT,char(allnames),repmat('m',2*3*nmarks,1),120,'20_01.mrd');

% fid = fopen('20_01.data','w');
% for i=1:frames
%     fprintf( fid,'%s\n',sprintf('% f ',OUTPUT(i,:)));
% end
% fclose(fid);
% save('20_01.data','OUTPUT','-ASCII');

