#ifndef _primus_fast4_H
#define _primus_fast4_H

#include "SDModel.h"

typedef struct {
    int ground_,nbod_,ndof_,ncons_,nloop_,nldof_,nloopc_,nball_,nlball_,npres_,
      nuser_;
    int jtype_[34],inb_[34],outb_[34],njntdof_[34],njntc_[34],njntp_[34],firstq_
      [34],ballq_[34],firstm_[34],firstp_[34];
    int trans_[29];
} sdgtopo_primus_fast4_t;
typedef struct {
    double grav_[3],mk_[34],ik_[34][3][3],pin_[29][3];
    double rk_[34][3],ri_[34][3],pres_[29],stabvel_,stabpos_;
    int mfrcflg_,roustate_,vpkflg_,inerflg_,mmflg_,mmlduflg_,wwflg_,ltauflg_,
      fs0flg_,ii_,mmap_[29];
    int gravq_[3],mkq_[34],ikq_[34][3][3],pinq_[29][3],rkq_[34][3],riq_[34][3],
      presq_[29],stabvelq_,stabposq_;
    double mtot_,psmkg_,rhead_[34][3],rcom_[34][3],mkrcomt_[34][3][3],psikg_[3][
      3],psrcomg_[3],psrkg_[3],psrig_[3],psmk_[29],psik_[29][3][3],psrcom_[29][3
      ],psrk_[29][3],psri_[29][3];
} sdginput_primus_fast4_t;
typedef struct {
    double curtim_,q_[30],qn_[30],u_[29],cnk_[29][3][3],cnb_[34][3][3];
    double rnk_[29][3],vnk_[29][3],wk_[29][3],rnb_[34][3],vnb_[34][3],wb_[34][3]
      ,wbrcom_[34][3],com_[3],rnkg_[3];
    double Cik_[29][3][3],rikt_[29][3][3],Iko_[29][3][3],mkrk_[29][3][3],Cib_[34
      ][3][3];
    double Wkk_[29][3],Vkk_[29][3],dik_[29][3],rpp_[29][3],rpk_[29][3],rik_[29][
      3],rik2_[29][3];
    double rpri_[29][3],Wik_[29][3],Vik_[29][3],Wirk_[29][3],rkWkk_[29][3],
      Wkrpk_[29][3],VikWkr_[29][3];
    double perr_[1],verr_[1],aerr_[1],mult_[1],ufk_[34][3],utk_[34][3],mfk_[34][
      3],mtk_[34][3];
    double utau_[29],mtau_[29],uacc_[29],uvel_[29],upos_[30];
    double s6_,c6_,s7_,c7_,s8_,c8_,s9_,c9_,s10_,c10_,s11_,c11_,s12_,c12_,s13_,
      c13_,s14_,c14_,s15_,c15_,s16_,c16_,s17_,c17_,s18_,c18_,s19_,c19_,s20_,c20_
      ,s21_,c21_,s22_,c22_,s23_,c23_,s24_,c24_,s25_,c25_,s26_,c26_,s27_,c27_,
      s28_,c28_;
} sdgstate_primus_fast4_t;
typedef struct {
    double fs0_[29],qdot_[30],Otk_[29][3],Atk_[29][3],AiOiWi_[29][3],Fstar_[29][
      3];
    double Tstar_[29][3],Fstark_[29][3],Tstark_[29][3],IkWk_[29][3],WkIkWk_[29][
      3],gk_[29][3],IkbWk_[34][3],WkIkbWk_[34][3];
    double w0w0_[34],w1w1_[34],w2w2_[34],w0w1_[34],w0w2_[34],w1w2_[34];
    double w00w11_[34],w00w22_[34],w11w22_[34],ww_[1][1],qraux_[1];
    double mm_[29][29],mlo_[29][29],mdi_[29],IkWpk_[29][29][3],works_[29],
      workss_[29][29];
    double Wpk_[29][29][3],Vpk_[29][29][3],VWri_[29][29][3];
    int wmap_[1],multmap_[1],jpvt_[1],wsiz_,wrank_;
} sdglhs_primus_fast4_t;
typedef struct {
    double fs_[29],udot_[29],tauc_[29],dyad_[34][3][3],fc_[29][3],tc_[29][3];
    double ank_[29][3],onk_[29][3],Onkb_[29][3],AOnkri_[29][3],Ankb_[29][3],
      AnkAtk_[29][3],anb_[34][3],onb_[34][3],dyrcom_[34][3];
    double ffk_[29][3],ttk_[29][3],fccikt_[29][3],ffkb_[34][3],ttkb_[34][3];
} sdgrhs_primus_fast4_t;
typedef struct {
    double temp_[3000],tmat1_[3][3],tmat2_[3][3],tvec1_[3],tvec2_[3],tvec3_[3],
      tvec4_[3],tvec5_[3];
    double tsc1_,tsc2_,tsc3_;
} sdgtemp_primus_fast4_t;

typedef struct {
    int lasterr_,lastrou_;
} sdgerror_primus_fast4_t;

#ifdef __cplusplus
class primus_fast4: public SDModel{
     protected:
        sdgtopo_primus_fast4_t sdgtopo;
        sdginput_primus_fast4_t sdginput;
        sdgstate_primus_fast4_t sdgstate;
        sdglhs_primus_fast4_t sdglhs;
        sdgrhs_primus_fast4_t sdgrhs;
        sdgtemp_primus_fast4_t sdgtemp;
        sdgerror_primus_fast4_t sdgerror;
        int *idx_2_joint;
        int *idx_2_axis;
        int *idx_2_aux;
        int *idx_2_motor;
        int num_controls;
                        
     public:
        primus_fast4();
        ~primus_fast4();
        
void sdinit(void);
void sdst2ang(double st[30],    double stang[29]);
void sdang2st(double stang[29],    double st[30]);
void sdnrmsterr(double st[30],    double normst[30],    int routine);
void sdnormst(double st[30],    double normst[30]);
void sdstate(double timein,    double qin[30],    double uin[29]);
void sdqdot(double oqdot[30]);
void sdu2qdot(double uin[29],    double oqdot[30]);
void sdpsstate(double lqin[1]);
void sddovpk(void);
void sddoltau(void);
void sddoiner(void);
void sddofs0(void);
void sddomm(int routine);
void sddommldu(int routine);
void sdlhs(int routine);
void sdmfrc(double imult[1]);
void sdequivht(double tau[29]);
void sdfs0(void);
void sdfsmult(void);
void sdfsfull(void);
void sdfsgenmult(void);
void sdfsgenfull(void);
void sdfulltrq(double udotin[29],    double multin[1],    double trqout[29]);
void sdcomptrq(double udotin[29],    double trqout[29]);
void sdmulttrq(double multin[1],    double trqout[29]);
void sdrhs(void);
void sdmassmat(double *mmat);//29][29]);
void sdfrcmat(double fmat[29]);
void sdpseudo(double lqout[1],    double luout[1]);
void sdpsqdot(double lqdout[1]);
void sdpsudot(double ludout[1]);
void sdperr(double errs[1]);
void sdverr(double errs[1]);
void sdaerr(double errs[1]);
int sdchkbnum(int routine,    int bnum);
int sdchkjnum(int routine,    int jnum);
int sdchkucnum(int routine,    int ucnum);
int sdchkjaxis(int routine,    int jnum,    int axnum);
int sdchkjpin(int routine,    int jnum,    int pinno);
int sdindx(int joint,    int axis);
void sdpresacc(int joint,    int axis,    double prval);
void sdpresvel(int joint,    int axis,    double prval);
void sdprespos(int joint,    int axis,    double prval);
void sdgetht(int joint,    int axis,    double *torque);
void sdhinget(int joint,    int axis,    double torque);
void sdpointf(int body,    double point[3],    double force[3]);
void sdbodyt(int body,    double torque[3]);
void sddoww(int routine);
void sdxudot0(int routine,    double oudot0[29]);
void sdudot0(double oudot0[29]);
void sdsetudot(double iudot[29]);
void sdxudotm(int routine,    double imult[1],    double oudotm[29]);
void sdudotm(double imult[1],    double oudotm[29]);
void sdderiv(double oqdot[30],    double oudot[29]);
void sdresid(double eqdot[30],    double eudot[29],    double emults[1],    double resid[59]);
void sdmult(double omults[1],    int *owrank,    int omultmap[1]);
void sdreac(double force[34][3],    double torque[34][3]);
void sdmom(double lm[3],    double am[3],    double *ke);
void sdsys(double *mtoto,    double cm[3],    double icm[3][3]);
void sdpos(int body,    double pt[3],    double loc[3]);
void sdvel(int body,    double pt[3],    double velo[3]);
void sdorient(int body,    double dircos[3][3]);
void sdangvel(int body,    double avel[3]);
void sdtrans(int frbod,    double ivec[3],    int tobod,    double ovec[3]);
void sdrel2cart(int coord,    int body,    double point[3],    double linchg[3],    double rotchg[3]);
void sdacc(int body,    double pt[3],    double accel[3]);
void sdangacc(int body,    double aacc[3]);
void sdgrav(double gravin[3]);
void sdmass(int body,    double massin);
void sdiner(int body,    double inerin[3][3]);
void sdbtj(int joint,    double btjin[3]);
void sditj(int joint,    double itjin[3]);
void sdpin(int joint,    int pinno,    double pinin[3]);
void sdpres(int joint,    int axis,    int presin);
void sdconschg(void);
void sdstab(double velin,    double posin);
void sdgetgrav(double gravout[3]);
void sdgetmass(int body,    double *massout);
void sdgetiner(int body,    double inerout[3][3]);
void sdgetbtj(int joint,    double btjout[3]);
void sdgetitj(int joint,    double itjout[3]);
void sdgetpin(int joint,    int pinno,    double pinout[3]);
void sdgetpres(int joint,    int axis,    int *presout);
void sdgetstab(double *velout,    double *posout);
void sdinfo(int info[50]);
void sdjnt(int joint,    int info[50],    int tran[6]);
void sdcons(int consno,    int info[50]);
void sdgentime(int *gentm);

        // user-defined functions
        void sduforce(double t, double *q, double *u);
        void sdumotion(double t, double *q, double *u);
        
        void sduaerr(double t, double *q, double *u, double *udot, double *errs);
        void sduconsfrc(double t, double *q, double *u, double *mults);
        void sduderiv(double t, double *y, double *dy, double *params, int *status);
        void sdueval(double *vars, double *params, double *redid);
        void sduperr(double t, double *q, double *errs);
        void sduverr(double t, double *q, double *u, double *errs);
        
        void sderror(int *routine, int *errnum);
        void sdclearerr(void);
        
        void set_aux(int *map); // pass in an array of aux numbers
        
  //      primus_fast4 operator= (primus_fast4);
        
        int NQ(void);   // get number of q coordinates
        int NU(void);   // get number of u coordinates
		int BQ(void);	// number of base coordinates (6 if floating, 0 otherwise)
        int NM(void);   // number of control joints ("motors")
        int NBOD(void);   // number of bodies
        int NJNT(void);     // number of joints
        
        int joint(int idx); // get joint number of coordinate
        int axis(int idx);  // get axis of coordinate
        int aux(int idx); // get aux number of coordinate
        int motor(int idx); // get the coordinate of motor

        double *get_massmat_ptr(void);
		//double **M;
        
//         double * get_q(int i);
//         double * get_u(int i);
//         double * get_qdot(int i);
//         double * get_udot(int i);
//         double *q_local, *u_local, *qdot_local, *udot_local, *u_zero;
};
#else
typedef struct primus_fast4 primus_fast4;
#endif



#endif
